package sql

import (
	"context"
	"tercul/internal/domain"
	"tercul/internal/platform/config"

	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/trace"
	"gorm.io/gorm"
)

type publisherRepository struct {
	domain.BaseRepository[domain.Publisher]
	db     *gorm.DB
	tracer trace.Tracer
}

// NewPublisherRepository creates a new PublisherRepository.
func NewPublisherRepository(db *gorm.DB, cfg *config.Config) domain.PublisherRepository {
	return &publisherRepository{
		BaseRepository: NewBaseRepositoryImpl[domain.Publisher](db, cfg),
		db:             db,
		tracer:         otel.Tracer("publisher.repository"),
	}
}

// ListByCountryID finds publishers by country ID
func (r *publisherRepository) ListByCountryID(ctx context.Context, countryID uint) ([]domain.Publisher, error) {
	ctx, span := r.tracer.Start(ctx, "ListByCountryID")
	defer span.End()
	var publishers []domain.Publisher
	if err := r.db.WithContext(ctx).Where("country_id = ?", countryID).Find(&publishers).Error; err != nil {
		return nil, err
	}
	return publishers, nil
}
